#!/usr/bin/env python
import inspect
from getclass import getclass
import formatvalue
from objectname import objectname
from public import public


def _formatvalue(value):
    return ""


def slice_args(args, function, firstarg):
    if not firstarg:
        cls = getclass(function)
        if inspect.isclass(function) or cls:
            args = args[1:]
    return args

# inspect.getargspec(function)
# TypeError: <built-in function chdir> is not a Python function


@public
def formatfunction(function, name=True, fullname=True,
                   formatvalue=formatvalue.formatvalue, firstarg=True):
    """todo"""
    func_name = ""
    if name:
        func_name = objectname(function, fullname)
    try:
        argspec = inspect.getargspec(function)
    except Exception:
        return "%s()" % str(func_name)
    if not formatvalue:
        formatvalue = _formatvalue

    args = slice_args(argspec.args, function, firstarg)
    result = inspect.formatargspec(args, *argspec[1:], formatvalue=formatvalue)
    return "%s%s" % (func_name, result)
